import java.util.Vector;
import java.util.Enumeration;

class Btree {

    public int value;
    public Btree right;
    public Btree left;

    public Btree (int v,Btree l, Btree r) {
	value = v;
	right = r;
	left = l;
    }
    public void insert_sort (int v) {
	if (v==value) {
	    return;
	} else if (v>value) {
	    if (left==null) {
		left = new Btree(v,null,null);
	    } else {
		left.insert_sort(v);
	    }
	} else if (v<value) {
	    if (right==null) {
		right = new Btree(v,null,null);
	    } else {
		right.insert_sort(v);
	    }
	}
    }

    public void walk () {
	if (right!=null) { right.walk(); }
	System.out.print(value);
	System.out.print(" ");
	if (left!=null) { left.walk(); }
    }

    public void append (Btree t) {
	Btree next=this;
	if (next.right==null) {
	    next.right = new Btree(0,t,null);
	} else {
	    next.right.append(t);
	}
    }

    public void breadth_walk () {
      Btree level = new Btree(0,this,null);
      Btree next,last;
      next =  new Btree(0,null,null);
      while(level!=null) {
          next.right = null;
          last = next;
          while(level!=null) {
              Btree b = level.left;
              System.out.print(b.value);
              System.out.print(" ");
              if(b.left!=null) { 
                  last.right = new Btree(0,b.left,null);
                  last = last.right;
              }
              if(b.right!=null) { 
                  last.right = new Btree(0,b.right,null);
                  last = last.right;
              }
              level = level.right;
          }
          System.out.print("\n");
          level = next.right;
      }
      System.out.print("\n");
    }

    public void breadth_walk1 () {
	Vector level = new Vector();
	Vector next;
	level.addElement(this);
	while(! level.isEmpty()) {
	    next = new Vector();
	    for (Enumeration e = level.elements() ; e.hasMoreElements() ;) {
		Btree b = (Btree) e.nextElement();
		System.out.print(b.value);
		System.out.print(" ");
		if(b.left!=null) { 
		    next.addElement(b.left);
		}
		if(b.right!=null) { 
		    next.addElement(b.right);
		}
	    }
	    System.out.print("\n");
	    level = next;
	}
	System.out.print("\n");
    }
}

